#ifndef PCH_H
#define PCH_H

#ifdef LIVE555_EXPORTS
#define LIVE555_API __declspec(dllexport)
#else
#define LIVE555_API __declspec(dllimport)
#endif

#if (defined(__WIN32__) || defined(_WIN32)) && !defined(__MINGW32__)
#include <ctime>
extern "C" int initializeWinsockIfNecessary();
#else
#include <cstdarg>
#include <ctime>
#include <sys/time.h>
#if !defined(_WIN32)
#include <netinet/tcp.h>
#ifdef __ANDROID_NDK__
#include <android/ndk-version.h>
#define ANDROID_OLD_NDK __NDK_MAJOR__ < 17
#endif
#endif
#include <fcntl.h>
#define initializeWinsockIfNecessary() 1
#endif

#if defined(__WIN32__) || defined(_WIN32) || defined(_QNX4)
#else
#include <signal.h>
#define USE_SIGNALS 1
#endif

#include <cassert>
#include <cstdio>
#include <fcntl.h>
#include <io.h>
#include <locale.h>
#include <cmath>
#include <ctype.h>
#include <errno.h>
#include <signal.h>
#include <sstream>
#include <cstdarg>
#include <cstddef>
#include <cstdint>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctime>

#ifdef FD_SETSIZE
#error FD_SETSIZE should be defined before including <ws2tcpip.h> and shoud be equal to 32768
#endif

#define FD_SETSIZE 32768

#if defined(__WIN32__) || defined(_WIN32) || defined(_WIN32_WCE)
/* Windows */
#if defined(WINNT) || defined(_WINNT) || defined(__BORLANDC__) || defined(__MINGW32__) || defined(_WIN32_WCE) || defined (_MSC_VER)
#define _MSWSOCK_
#include <ws2tcpip.h>
#endif
#endif

#include <windows.h>
#include <winsock2.h>
#include <ws2tcpip.h>

#include <Boolean.hh>
#include <Groupsock.hh>
#include <GroupsockHelper.hh>
#include <H264VideoRTPSink.hh>
#include <H264VideoStreamDiscreteFramer.hh>
#include <Media.hh>
#include <MPEG1or2AudioRTPSink.hh>
#include <NetCommon.h> // for u_int32_t, u_int64_t
#include <strDup.hh>

#include <UsageEnvironment.hh>

std::string TimevalToString(const struct timeval& tv);

#endif //PCH_H
